package tsp.csc4509.appli;

import static tsp.csc4509.common.Log.COMM;
import static tsp.csc4509.common.Log.GEN;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.nio.channels.SocketChannel;

import org.apache.logging.log4j.Level;

import tsp.csc4509.common.Log;
import tsp.csc4509.tcpnio.FullDuplexMsgWorker;
import tsp.csc4509.tcpnio.ReadMessageStatus;
import tsp.csc4509.tpnote.MessType;
import tsp.csc4509.tpnote.Node;
import tsp.csc4509.tpnote.TaskRequest;
import tsp.csc4509.tpnote.TaskResponse;

public class AppliNode {
	/**
	 * 
	 */
	private static final int ROOTNODE_NBARGS = 4;
	private static final int OTHERNODES_NBARGS = 7;
	
	/**
	 * position du numéro du noeud (pour les affichage de de débug)
	 */
	private static final int NUMARG = 0;
	/**
	 * position du numéro de port de ce noeud dans argv[].
	 */
	private static final int MYPORTARG = 1;
	
	private static final int SERVERHOSTARG = 2;
	private static final int SERVERPORTARG = 3;
	
	
	
	private static  final int FATHERNUMARG = 4;
	/**
	 * position du nom de la machine du noeud à connecter dans argv[]. 
	 */
	private static  final int FATHERHOSTARG = 5;
	/**
	 * position du numetto de port du noeud à connecter dans argv[].
	 */
	private static  final int FATHERPORTARG = 6;

	public static FullDuplexMsgWorker connectTo(final InetSocketAddress addr) throws IOException {
		SocketChannel rwChan = SocketChannel.open(addr);
		return new FullDuplexMsgWorker(rwChan);
	}

	public static void main(final String[] argv) throws IOException, InterruptedException {
		if (argv.length != ROOTNODE_NBARGS && argv.length != OTHERNODES_NBARGS ) {
			System.err.println("usage (noeud racine): AppliNode <num du noeud> <monPort> <host du serveur> <port du serveur> ");
			System.err.println("  ou   (autre noeud): AppliNode <num du noeud> <monPort> <host du serveur> <numro du père>  <port du serveur> <host noeud pere> <port noeud pere>");
			System.exit(1);
		}
		
		Log.setLevel(COMM, Level.INFO);
		Log.setLevel(GEN, Level.INFO);
		
		try {
			int myNum = 0;
			int myPort = 0;
			int serverPort = 0;
			int fatherNum = 0;
			int fatherPort = 0;

			Node node;
			myNum = Integer.parseInt(argv[NUMARG]);
			myPort = Integer.parseInt(argv[MYPORTARG]);
			serverPort = Integer.parseInt(argv[SERVERPORTARG]);
			if (argv.length ==  ROOTNODE_NBARGS) {
				
				node = new Node(myNum, myPort, argv[SERVERHOSTARG], serverPort);
			} else {
				fatherNum = Integer.parseInt(argv[FATHERNUMARG]);
				fatherPort = Integer.parseInt(argv[FATHERPORTARG]);
				node = new Node(myNum, myPort, argv[SERVERHOSTARG], serverPort, fatherNum, argv[FATHERHOSTARG], fatherPort);
			}
			
			node.algoNaimiTrehel();
			

		} catch (NumberFormatException e) {
			System.err.println("Les numéros de port et le numéro du noeud doivent être des entiers");
			System.err.println("usage (noeud racine): AppliNode <num du noeud> <monPort> <host du serveur> <port du serveur> ");
			System.err.println("  ou   (autre noeud): AppliNode <num du noeud> <monPort> <host du serveur> <port du serveur> <numro du père> <host noeud pere> <port noeud pere>");
			System.exit(1);
		}
		
	}
	
}
