package tsp.csc4509.common;

import java.net.InetAddress;
import java.net.NetworkInterface;
import java.net.SocketException;
import java.util.Enumeration;
import java.util.Iterator;

public class NetTools {
	
	/**
	 * Retourne une adresse InetAddress d'une interface réseau UP et de préférence pas celle
	 * de loopback.
	 * @return
	 *      une adresse InetAddress d'une interface réseau UP et de préférence pas celle
	 *      de loopback.
	 * @throws SocketException
	 *      
	 */
	public static  InetAddress giveANoneLoopbackAddr() throws SocketException {
		Enumeration<NetworkInterface> netInterfaces = NetworkInterface.getNetworkInterfaces();
		InetAddress badResult = null;;
		
		Iterator<NetworkInterface> itInterface =  netInterfaces.asIterator();
		
		// parcours de toutes les interfaces réseau de la machine.
		while (itInterface.hasNext()) {
			NetworkInterface netInterface = itInterface.next();
			// on ne garde que le interface UP.
			if (!netInterface.isUp()) {
				continue;
			}
			Enumeration<InetAddress> addrs=  netInterface.getInetAddresses();
			Iterator<InetAddress> itAddr = addrs.asIterator();
			while (itAddr.hasNext()) {
				InetAddress addr = itAddr.next();
				// on met de coté l'adresse IP de loopback en solution de replis.
				if (netInterface.isLoopback()) {
					badResult = addr;
				}
				else {
					// on garde la première adresse qui respecte les conditions.
					return addr;
				}
				
			}
			
		}
		
		// soit on n'a trouvé aucune adresse (resultat null) soit on n'a trouvé que l'adresse de loopback.
		return badResult;
	}

}
