package tsp.csc4509.debug;

import java.util.ArrayList;
import java.util.List;

public class Debug {

	private List<DebugNode> links;

	public Debug() {
		links = new ArrayList<>();
	}

	public void addNewNode(final int nodeNum, final DebugNode debugNode ) {
		while (links.size() <= nodeNum) { // les noeuds ne sont  pas forcement dans l'ordre dans cette liste 
			links.add(null);
		}
		links.set(nodeNum, debugNode);
		
	}

	public boolean changeLink(final int nodeNum, final int fatherNum, final boolean havingToken, final boolean requesting) {
		DebugNode debugNode = new DebugNode(fatherNum, havingToken, requesting);
		if (links.size() <= nodeNum || links.get(nodeNum) == null) {
			addNewNode(nodeNum, debugNode);
			return true;

		}
		if (! links.get(nodeNum).equals(debugNode)) {
			
			links.set(nodeNum, debugNode);
			
			return true;
		}
		
		return false;
	}

	@Override
	public String toString() {
		String res = "";

		for (int ind = 0; ind < links.size(); ind++) {
			DebugNode debugNode = links.get(ind);
			if (debugNode != null)  {
				res += ind + "(";
				if (debugNode.isHavingToken()) {
					res += "T";
				}
				if (debugNode.isRequesting()) {
					res += "R";
				}
				res += ")->" + (debugNode.getLink() == -1 ? "X" :  debugNode.getLink()) + ", ";
			}
		}

		return res;
	}



}
