package tsp.csc4509.tpnote;

import java.io.Serializable;
import java.util.Objects;

/**
 * Classe contenant la demande d'entrée en section critique émise par un noeud qui
 * souhaite obtenir la ressource critique.
 * @author Éric Lallet
 *
 */
public class ResourceRequest implements Serializable {
	private static final long serialVersionUID = 1L;
	/**
	 * id du noeud réclamant la ressource critique.
	 */
	private NodeId nodeId;

	/**
	 * Constructeur à partir d'id du noeud qui réclame la ressource critique.
	 * @param nodeId
	 */
	public ResourceRequest(NodeId nodeId) {
		super();
		this.nodeId = nodeId;
	}

	/**
	 * getter sur l'id du noeud réclamant la ressource critique.
	 * @return
	 *        id du noeud réclamant la ressource critique.
	 */
	public NodeId getNodeId() {
		return nodeId;
	}

	@Override
	public int hashCode() {
		return Objects.hash(nodeId);
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ResourceRequest other = (ResourceRequest) obj;
		return Objects.equals(nodeId, other.nodeId);
	}
	
	
}
